From ac0bf1880847507317a6d7b871fae4f28f783048 Mon Sep 17 00:00:00 2001
From: Masahiko Sawada <sawada.mshk@gmail.com>
Date: Sun, 10 Jun 2018 18:44:42 +0900
Subject: [PATCH v19 2/4] Support atomic commit among multiple foreign servers.

---
 doc/src/sgml/catalogs.sgml                    |   97 +
 doc/src/sgml/config.sgml                      |  124 ++
 doc/src/sgml/distributed-transaction.sgml     |  152 ++
 doc/src/sgml/fdwhandler.sgml                  |  192 ++
 doc/src/sgml/filelist.sgml                    |    1 +
 doc/src/sgml/func.sgml                        |   51 +
 doc/src/sgml/monitoring.sgml                  |   56 +
 doc/src/sgml/postgres.sgml                    |    1 +
 src/backend/access/Makefile                   |    2 +-
 src/backend/access/fdwxact/Makefile           |   17 +
 src/backend/access/fdwxact/TAGS               |    1 +
 src/backend/access/fdwxact/fdwxact.c          | 2610 +++++++++++++++++++++++++
 src/backend/access/fdwxact/fdwxact_launcher.c |  641 ++++++
 src/backend/access/fdwxact/fdwxact_resolver.c |  331 ++++
 src/backend/access/rmgrdesc/Makefile          |    8 +-
 src/backend/access/rmgrdesc/fdwxactdesc.c     |   65 +
 src/backend/access/rmgrdesc/xlogdesc.c        |    6 +-
 src/backend/access/transam/Makefile           |    6 +-
 src/backend/access/transam/rmgr.c             |    1 +
 src/backend/access/transam/twophase.c         |   42 +
 src/backend/access/transam/xact.c             |   26 +-
 src/backend/access/transam/xlog.c             |   32 +-
 src/backend/catalog/system_views.sql          |   11 +
 src/backend/commands/foreigncmds.c            |   23 +
 src/backend/executor/execPartition.c          |    4 +
 src/backend/executor/nodeForeignscan.c        |    8 +
 src/backend/executor/nodeModifyTable.c        |    5 +
 src/backend/foreign/foreign.c                 |   43 +
 src/backend/postmaster/bgworker.c             |    8 +
 src/backend/postmaster/pgstat.c               |   18 +
 src/backend/postmaster/postmaster.c           |   15 +-
 src/backend/replication/logical/decode.c      |    1 +
 src/backend/storage/ipc/ipci.c                |    6 +
 src/backend/storage/ipc/procarray.c           |   46 +
 src/backend/storage/lmgr/lwlocknames.txt      |    2 +
 src/backend/storage/lmgr/proc.c               |    8 +
 src/backend/tcop/postgres.c                   |   14 +
 src/backend/utils/misc/guc.c                  |   61 +
 src/backend/utils/misc/postgresql.conf.sample |   16 +
 src/backend/utils/probes.d                    |    2 +
 src/bin/initdb/initdb.c                       |    1 +
 src/bin/pg_controldata/pg_controldata.c       |    2 +
 src/bin/pg_resetwal/pg_resetwal.c             |    2 +
 src/bin/pg_waldump/rmgrdesc.c                 |    1 +
 src/include/access/fdwxact.h                  |  150 ++
 src/include/access/fdwxact_launcher.h         |   32 +
 src/include/access/fdwxact_resolver.h         |   23 +
 src/include/access/fdwxact_xlog.h             |   52 +
 src/include/access/resolver_internal.h        |   67 +
 src/include/access/rmgrlist.h                 |    1 +
 src/include/access/twophase.h                 |    1 +
 src/include/access/xact.h                     |    7 +
 src/include/access/xlog_internal.h            |    1 +
 src/include/catalog/pg_control.h              |    1 +
 src/include/catalog/pg_proc.dat               |   23 +
 src/include/foreign/fdwapi.h                  |   18 +-
 src/include/foreign/foreign.h                 |    2 +-
 src/include/pgstat.h                          |    8 +-
 src/include/storage/proc.h                    |   10 +
 src/include/storage/procarray.h               |    5 +
 src/include/utils/guc_tables.h                |    2 +
 src/test/regress/expected/rules.out           |   12 +
 62 files changed, 5147 insertions(+), 27 deletions(-)
 create mode 100644 doc/src/sgml/distributed-transaction.sgml
 create mode 100644 src/backend/access/fdwxact/Makefile
 create mode 120000 src/backend/access/fdwxact/TAGS
 create mode 100755 src/backend/access/fdwxact/fdwxact.c
 create mode 100644 src/backend/access/fdwxact/fdwxact_launcher.c
 create mode 100644 src/backend/access/fdwxact/fdwxact_resolver.c
 create mode 100644 src/backend/access/rmgrdesc/fdwxactdesc.c
 create mode 100644 src/include/access/fdwxact.h
 create mode 100644 src/include/access/fdwxact_launcher.h
 create mode 100644 src/include/access/fdwxact_resolver.h
 create mode 100644 src/include/access/fdwxact_xlog.h
 create mode 100644 src/include/access/resolver_internal.h

diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index 6d6fbec..9d99cdc 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -9622,6 +9622,103 @@ SELECT * FROM pg_locks pl LEFT JOIN pg_prepared_xacts ppx
 
  </sect1>
 
+ <sect1 id="view-pg-prepared-fdw-xacts">
+  <title><structname>pg_prepared_fdw_xacts</structname></title>
+
+  <indexterm zone="view-pg-prepared-fdw-xacts">
+   <primary>pg_prepared_fdw_xacts</primary>
+  </indexterm>
+
+  <para>
+   The view <structname>pg_prepared_fdw_xacts</structname> displays
+   information about foreign transactions that are currently prepared on
+   foreign servers for atomic distributed transaction commit (see
+   <xref linkend="fdw-transaction-managements"/> for details).
+  </para>
+
+  <para>
+   <structname>pg_prepared_xacts</structname> contains one row per prepared
+   foreign transaction.  An entry is removed when the foreign transaction is
+   committed or rolled back.
+  </para>
+
+  <table>
+   <title><structname>pg_prepared_fdw_xacts</structname> Columns</title>
+
+   <tgroup cols="4">
+    <thead>
+     <row>
+      <entry>Name</entry>
+      <entry>Type</entry>
+      <entry>References</entry>
+      <entry>Description</entry>
+     </row>
+    </thead>
+    <tbody>
+     <row>
+      <entry><structfield>dbid</structfield></entry>
+      <entry><type>oid</type></entry>
+      <entry><literal><link linkend="catalog-pg-database"><structname>pg_database</structname></link>.oid</literal></entry>
+      <entry>
+       OID of the database which the foreign transaction resides in
+      </entry>
+     </row>
+     <row>
+      <entry><structfield>transaction</structfield></entry>
+      <entry><type>xid</type></entry>
+      <entry></entry>
+      <entry>
+       Transaction id that this foreign transaction associates with
+      </entry>
+     </row>
+     <row>
+      <entry><structfield>serverid</structfield></entry>
+      <entry><type>oid</type></entry>
+      <entry><literal><link linkend="catalog-pg-foreign-server"><structname>pg_foreign_server</structname></link>.oid</literal></entry>
+      <entry>
+       The OID of the foreign server that this foreign server is prepared
+      </entry>
+     </row>
+     <row>
+      <entry><structfield>userid</structfield></entry>
+      <entry><type>oid</type></entry>
+      <entry><literal><link linkend="view-pg-user"><structname>pg_user</structname></link>.oid</literal></entry>
+      <entry>
+       The OID of the user that prepared this foreign transaction.
+      </entry>
+     </row>
+     <row>
+      <entry><structfield>status</structfield></entry>
+      <entry><type>text</type></entry>
+      <entry></entry>
+      <entry>
+       Status of foreign transaction: <literal>prepared</literal>, <literal>committing</literal>, <literal>aborting</literal> or <literal>unknown</literal>
+      </entry>
+     </row>
+     <row>
+      <entry><structfield>identifier</structfield></entry>
+      <entry><type>text</type></entry>
+      <entry></entry>
+      <entry>
+       The identifier of the prepared foreign transaction.
+      </entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+
+  <para>
+   When the <structname>pg_prepared_xacts</structname> view is accessed, the
+   internal transaction manager data structures are momentarily locked, and
+   a copy is made for the view to display.  This ensures that the
+   view produces a consistent set of results, while not blocking
+   normal operations longer than necessary.  Nonetheless
+   there could be some impact on database performance if this view is
+   frequently accessed.
+  </para>
+
+ </sect1>
+
  <sect1 id="view-pg-publication-tables">
   <title><structname>pg_publication_tables</structname></title>
 
diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
index 7554cba..589ef6e 100644
--- a/doc/src/sgml/config.sgml
+++ b/doc/src/sgml/config.sgml
@@ -1547,6 +1547,29 @@ include_dir 'conf.d'
       </listitem>
      </varlistentry>
 
+     <varlistentry id="guc-max-prepared-foreign-transactions" xreflabel="max_prepared_foreign_transactions">
+      <term><varname>max_prepared_foreign_transactions</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>max_prepared_foreign_transactions</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Sets the maximum number of foreign transactions that can be prepared
+        simultaneously. A single local transaction can give rise to multiple
+        foreign transaction. If <literal>N</literal> local transactions each
+        across <literal>K</literal> foreign server this value need to be set
+        <literal>N * K</literal>, not just <literal>N</literal>.
+        This parameter can only be set at server start.
+       </para>
+       <para>
+        When running a standby server, you must set this parameter to the
+        same or higher value than on the master server. Otherwise, queries
+        will not be allowed in the standby server.
+       </para>
+      </listitem>
+     </varlistentry>
+
      <varlistentry id="guc-work-mem" xreflabel="work_mem">
       <term><varname>work_mem</varname> (<type>integer</type>)
       <indexterm>
@@ -3612,6 +3635,78 @@ ANY <replaceable class="parameter">num_sync</replaceable> ( <replaceable class="
      </variablelist>
     </sect2>
 
+    <sect2 id="runtime-config-foreign-transaction-resolver">
+     <title>Foreign Transaction Resolvers</title>
+
+     <para>
+      These settings control the behavior of a foreign transaction resolver.
+     </para>
+
+     <variablelist>
+
+     <varlistentry id="guc-max-foreign-transaction-resolvers" xreflabel="max_foreign_transaction_resolvers">
+      <term><varname>max_foreign_transaction_resolvers</varname> (<type>int</type>)
+      <indexterm>
+       <primary><varname>max_foreign_transaction_resolvers</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Specifies maximum number of foreign transaction resolution workers. A foreign transaction
+        resolver is responsible for foreign transaction resolution on one database.
+       </para>
+       <para>
+        Foreign transaction resolution workers are taken from the pool defined by
+        <varname>max_worker_processes</varname>.
+       </para>
+       <para>
+        The default value is 0.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry id="foreign-transaction-resolution-rety-interval" xreflabel="foreign_transaction_resolution_retry_interval">
+      <term><varname>foreign_transaction_resolution_retry_interval</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>foreign_transaction_resolution_interval</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Specify how long the foreign transaction resolver should wait when the last resolution
+        fails before retrying to resolve foreign transaction. This parameter can only be set in the
+        <filename>postgresql.conf</filename> file or on the server command line.
+       </para>
+       <para>
+        The default value is 10 seconds.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     <varlistentry id="foreign-transaction-resolver-timeout" xreflabel="foreign_transaction_resolver_timeout">
+      <term><varname>foreign_transaction_resolver_timeout</varname> (<type>integer</type>)
+      <indexterm>
+       <primary><varname>foreign_transaction_resolver_timeout</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Terminate foreign transaction resolver processes that don't have any foreign
+        transactions to resolve longer than the specified number of milliseconds.
+        A value of zero disables the timeout mechanism.  You should set this value to
+        zero only if you set <varname>max_foreign_transaction_resolvers</varname> as
+        much as databases you have. This parameter can only be set in the
+        <filename>postgresql.conf</filename> file or on the server command line.
+       </para>
+       <para>
+        The default value is 60 seconds.
+       </para>
+      </listitem>
+     </varlistentry>
+
+     </variablelist>
+    </sect2>
+
    </sect1>
 
    <sect1 id="runtime-config-query">
@@ -7827,6 +7922,35 @@ dynamic_library_path = 'C:\tools\postgresql;H:\my_project\lib;$libdir'
      </variablelist>
    </sect1>
 
+   <sect1 id="runtime-config-foreign-transaction">
+    <title>Foreign Transaction Management</title>
+
+    <variablelist>
+
+     <varlistentry id="guc-foreign-twophase-commit" xreflabel="foreign_twophase_commit">
+      <term><varname>foreign_twophase_commit</varname> (<type>bool</type>)
+       <indexterm>
+        <primary><varname>foreign_twophase_commit</varname> configuration parameter</primary>
+       </indexterm>
+      </term>
+      <listitem>
+       <para>
+        Specifies whether transaction commit will wait for all involving foreign transaction
+        to be resolved before the command returns a "success" indication to the client.
+        Both <varname>max_prepared_foreign_transactions</varname> and
+        <varname>max_foreign_transaction_resolvers</varname> must be non-zero value to
+        allow foreign twophase commit to be used.
+       </para>
+       <para>
+        This parameter can be changed at any time; the behavior for any one transaction
+        is determined by the setting in effect when it commits.
+       </para>
+      </listitem>
+     </varlistentry>
+    </variablelist>
+
+   </sect1>
+
    <sect1 id="runtime-config-compatible">
     <title>Version and Platform Compatibility</title>
 
diff --git a/doc/src/sgml/distributed-transaction.sgml b/doc/src/sgml/distributed-transaction.sgml
new file mode 100644
index 0000000..54e582e
--- /dev/null
+++ b/doc/src/sgml/distributed-transaction.sgml
@@ -0,0 +1,152 @@
+<!-- doc/src/sgml/distributed-transaction.sgml -->
+
+<chapter id="distributed-transaction">
+ <title>Distributed Transaction Management</title>
+
+ <para>
+  This chapter explains what distributed transaction management is, and how it can be configured
+  in PostgreSQL.
+ </para>
+
+ <sect1 id="atomic-commit">
+  <title>Atomic Commit</title>
+
+  <para>
+   Atomic commit is an operation that applies a set of changes as a single operation
+   globally. <productname>PostgreSQL</productname> provides a way to perform a transaction
+   with foreign resources using <literal>Foreign Data Wrapper</literal>. Using the
+   <productname>PostgreSQL</productname>'s atomic commit ensures that all changes
+   on foreign servers end in either commit or rollback using the transaction callback
+   routines (see <xref linkend="fdw-callbacks-transaction-managements"/>).
+  </para>
+
+  <sect2>
+   <title>Atomic Commit Using Two-phase Commit Protocol</title>
+
+   <para>
+    To achieve commit among all foreign servers automatially,
+    <productname>PostgreSQL</productname> employees Two-phase commit protocol, which is a
+    type of atomic commitment protocol (ACP). Using Two-phase commit protocol, the commit
+    sequence of distributed transaction performs with the following steps.
+    <orderedlist>
+     <listitem>
+      <para>
+       Prepare all transactions on foreign servers.
+      </para>
+     </listitem>
+     <listitem>
+      <para>
+       Commit locally.
+      </para>
+     </listitem>
+     <listitem>
+      <para>
+       Resolve all prepared transaction on foreign servers.
+      </para>
+     </listitem>
+    </orderedlist>
+
+   </para>
+
+   <para>
+    At the first step, <productname>PostgreSQL</productname> distributed transaction manager
+    prepares all transaction on the foreign servers if two-phase commit is required.
+    Two-phase commit is required only if the transaction modifies data on two or more
+    servers including the local server itself and user requests it by
+    <xref linkend="guc-foreign-twophase-commit"/>. If all preparations on foreign servers
+    got successful go to the next step. Any faliure happens in this step
+    <productname>PostgreSQL</productname> changes over rollback, then rollback all transactions
+    on both local and foreign servers.
+   </para>
+
+   <para>
+    At the local commit step, <productname>PostgreSQL</productname> commit the transaction
+    locally. Any failure happens in this step <productname>PostgreSQL</productname> changes
+    over rollback, then rollback all transactions on both local and foreign servers.
+   </para>
+
+   <para>
+    At the final step, prepared transactions are resolved by a foreign Transaction
+    resolver process.
+   </para>
+  </sect2>
+
+  <sect2>
+   <title>Foreign Transaction Resolution</title>
+
+   <para>
+    Foreign transaction resolutions are performed by foreign transaction resolver process.
+    They commit all prepared transaction on foreign servers if the coordinator received
+    an agreement message from all foreign server during the first step. On the other hand,
+    if any foreign server failed to prepare the transaction, it rollbacks all prepared
+    transactions.
+   </para>
+
+   <para>
+    One foreign transaction resolver is responsible for transaction resolutions on one
+    database of the coordinator side. On failure during resolution, they retries to
+    resolve after <varname>foreign_transaction_resolution_interval</varname>.
+   </para>
+  </sect2>
+
+  <sect2>
+   <title>In-doubt Transactions</title>
+
+   <para>
+    The atomic commit mechanism ensures that all foreign servers either commit or rollback
+    using two-phase commit protocol. However, if the second phase fails for whatever reason
+    the transaction becomes in-doubt. The transactions becomes in-doubt in the following
+    situations:
+
+   <itemizedlist>
+    <listitem>
+     <para>
+      A local <productname>PostgreSQL</productname> server crashes during atomic commit
+      operation.
+     </para>
+    </listitem>
+
+    <listitem>
+     <para>
+      A local <productname>PostgreSQL</productname> server got a cancellation by user during
+      atomic commit.
+     </para>
+    </listitem>
+   </itemizedlist>
+
+   In-doubt transactions are automatically handled by foreign transaction resolver process
+   when there is no online transaction requesting resolutions.
+   <function>pg_resolve_fdw_xact</function> provides a way to resolve transactions on foreign
+   servers that are participate the distributed transaction manually.
+   </para>
+  </sect2>
+
+  <sect2>
+   <title>Monitoring</title>
+   <para>
+    The monitoring information about foreign transaction resolvers is visible in
+    <link linkend="pg-stat-fdwxact-resolver-view"><literal>pg_stat_fdwxact_resolver</literal></link>
+    view. This view contains one row for every foreign Transaction resolver worker.
+   </para>
+  </sect2>
+
+  <sect2>
+   <title>Configuration Settings</title>
+
+   <para>
+    Atomic commit requires several configuration options to be set.
+   </para>
+
+   <para>
+    On the coordinator side, <xref linkend="guc-max-prepared-foreign-transactions"/> and
+    <xref linkend="guc-max-foreign-transaction-resolvers"/> must be non-zero value.
+    Additionally the <varname>max_worker_processes</varname> may need to be adjusted to
+    accommodate for foreign transaction resolver workers, at least
+    (<varname>max_foreign_transaction_resolvers</varname> + <literal>1</literal>).
+    Note that some extensions and parallel queries also take worker slots from
+    <varname>max_worker_processes</varname>.
+   </para>
+
+  </sect2>
+ </sect1>
+</chapter>
diff --git a/doc/src/sgml/fdwhandler.sgml b/doc/src/sgml/fdwhandler.sgml
index 4ce88dd..5180ce0 100644
--- a/doc/src/sgml/fdwhandler.sgml
+++ b/doc/src/sgml/fdwhandler.sgml
@@ -1390,6 +1390,103 @@ ReparameterizeForeignPathByChild(PlannerInfo *root, List *fdw_private,
     </para>
    </sect2>
 
+   <sect2 id="fdw-callbacks-transaction-managements">
+    <title>FDW Routines For Transaction Managements</title>
+
+    <para>
+     If an FDW wishes to support <firstterm>atomic commit</firstterm>
+     (as described in <xref linkend="fdw-transaction-managements"/>), it must call the
+     registrasaction function <function>FdwXactRegisterForeignTransaction</function>
+     and provide the following callback functions:
+    </para>
+
+    <para>
+<programlisting>
+bool
+PrepareForeignTransaction(FdwXactResolveState *state);
+</programlisting>
+    Prepare the transaction on the foreign server. This function is called at the
+    pre-commit phase of the local transactions if atomic commit is required.
+    Returning <literal>true</literal> means that preparing the foreign
+    transaction got successful.
+    </para>
+    <para>
+<programlisting>
+bool
+CommitForeignTransaction(FdwXactResolveState *state);
+</programlisting>
+    Commit the not-prepared transaction on the foreign server.
+    This function is called at the pre-commit phase of local
+    transaction if atomic commit is not required. The atomic
+    commit is not required either when we modified data on
+    only one server including the local server or when userdoesn't
+    request atomic commit by <xref linkend="guc-foreign-twophase-commit"/>.
+    Returning <literal>true</literal> means that commit the
+    foreign transaction got successful.
+    </para>
+    <para>
+<programlisting>
+bool
+RollbackForeignTransaction(FdwXactResolveState *state);
+</programlisting>
+    Rollback a not-prepared transaction on the foreign server.
+    This function is called at the end of local transaction after
+    rollbacked locally either when user requested rollback or when
+    any error occurs during the transaction. This function could
+    be called recursively if any error occurs during rollback the
+    foreign transaction for whatever reason. You need to track
+    recursion and prevent this function from being called infinitely.
+    Returning <literal>true</literal> means that rollback the
+    foreign transaction got successful.
+    </para>
+    <para>
+<programlisting>
+bool
+ResolvePreparedForeignTransaction(FdwXactResolveState *state,
+                                  bool is_commit);
+</programlisting>
+    Commit or rollback the prepared transaction on the foreign server.
+    When <varname>is_commit</varname> is true, it indicates that the foreign
+    transaction should be committed. Otherwise the foreign transaction should
+    be aborted.
+    This function normally is called by the foreign transaction resolver
+    process but can also be called by <function>pg_resovle_fdw_xacts</function>
+    function. In the resolver process, this function is called either
+    when a backend requests the resolver process to resolve a distributed
+    transaction after prepared, or when a database has dangling
+    transactions. Returning <literal>true</literal> means that resolving
+    the foreign transaction got successful.
+    In abort case, please note that the prepared transaction identified
+    by <varname>state->fdwxact_id</varname> might not exist on the foreign
+    server. If you failed to resolve the foreign transaction due to undefined
+    object error (<literal>ERRCODE_UNDEFINED_OBJECT</literal>) you should
+   regards it as success and return <literal>true</literal>.
+    </para>
+    <para>
+<programlisting>
+bool
+IsTwoPhaseCommitEnabled(Oid serverid);
+</programlisting>
+    Return <literal>true</literal> if the foreign server identified by
+    <literal>serverid</literal> is capable of two-phase commit protocol.
+    This function is called when the transaction begins to modify data on
+    the foreign server. Return <literal>false</literal> indicates that
+    the current transaction cannot use atomic commit even if atomic commit
+    is requested by user.
+    </para>
+
+    <note>
+     <para>
+      Functions <function>PrepareForeignTransaction</function>,
+      <function>CommitForeignTransaction</function> and
+      <function>RolblackForeignTransaction</function> are called
+      at outside of a valid transaction state. So please note that
+      you cannot use functions that use the system catalog cache
+      such as Foreign Data Wrapper helper functions described in
+      <xref linkend="fdw-helpers"/>.
+     </para>
+    </note>
+   </sect2>
    </sect1>
 
    <sect1 id="fdw-helpers">
@@ -1835,4 +1932,99 @@ GetForeignServerByName(const char *name, bool missing_ok);
 
   </sect1>
 
+  <sect1 id="fdw-transaction-managements">
+    <title>Transaction managements for Foreign Data Wrappers</title>
+
+    <para>
+     <productname>PostgreSQL</productname> foreign transaction manager
+     allows FDWs to read and write data on foreign server within a transaction while
+     maintaining atomicity of the foreign data (aka atomic commit). Using
+     atomic commit, it guarantees that a distributed transaction is committed
+     or rollbacked on all participants foreign
+     server.  To achieve atomic commit, <productname>PostgreSQL</productname>
+     employees two-phase commit protocol, which is a type of atomic commitment
+     protocol. Every FDW that wish to support atomic commit
+     is required to support the transaction management callback routines
+     (see <xref linkend="fdw-callbacks-transaction-managements"/> for details)
+     and register the foreign transaction using
+     <function>FdwXactRegisterForeignTransaction</function> when starting a
+     transaction on the foreign server. Transaction of registered foreign server
+     is managed by the foreign transaction manager.
+<programlisting>
+void
+FdwXactRegisterForeignTransaction(Oid serverid, Oid userid, char *fx_id)
+</programlisting>
+    This function should be called when a transaction starts on the foreign server.
+    <varname>serverid</varname> and <varname>userid</varname> are <type>OID</type>s
+    which specify the transaction starts on what server by who. <varname>fx_id</varname>
+    is null-terminated string which is an identifer of foreign transaction and it
+    will be passed when transaction management APIs is called. The length of
+    <varname>fx_id</varname> must be less than 200 bytes. Also this identifier
+    must be unique enough so that it doesn't conflict other concurrent foreign
+    transactions. <varname>fx_id</varname> can be <literal>NULL</literal>.
+    If it's <literal>NULL</literal>, a unique transaction identifier is automacitally
+    generated with in the form of
+    <literal>fx_&lt;random value up to 2<superscript>31</superscript>&gt;_&lt;server oid&gt;_&lt;user oid&gt;</literal>.
+    Since this identifier is used per foreign transaction and the xid of unresolved
+    distributed transaction never reused, an auto-generated identifier is fairly
+    enough to ensure uniqueness. It's recommended to generate foreign transaction
+    identifier in FDW if the format of auto-generated identifier doesn't match
+    the requirement of the foreign server.
+    </para>
+
+    <para>
+     An example of such transaction is as follows
+<programlisting>
+BEGIN;
+UPDATE ft1 SET col = 'a';
+UPDATE ft2 SET col = 'b';
+COMMIT;
+</programlisting>
+    ft1 and ft2 are foreign tables on different foreign servers may be using different
+    Foreign Data Wrappers.
+    </para>
+
+    <para>
+     When a transaction starts on the foreign server, FDW that wishes atomic
+     commit must register the foreign transaction as a participant by calling
+     <function>FdwXactRegisterForeignTransaction</function>. Also during
+     transaction, <function>IsTwoPhaseCommitEnabled</function> is called whenever
+     the transaction begins to modify data on the foreign server. If FDW wishes
+     atomic commit <function>IsTwoPhaseCommitEnabled</function> must return
+     <literal>true</literal>. All foreign transaction participants must
+     return <literal>true</literal> to achieve atomic commit.
+    </para>
+
+    <para>
+     During pre-commit phase of local transaction, the foreign transaction manager
+     persists the foreign transaction information to the disk and WAL, and then
+     prepare all foreign transaction by calling <function>PrepareForeignTransaction</function>
+     if two-phase commit protocol is required. Two-phase commit is required only if
+     the transaction modified data on more than one servers including the local
+     server and user requests atomic commit. <productname>PostgreSQL</productname>
+     can commit locally and go to the next step if and only if all preparing foreign
+     transactions got successful. If two-phase commit is not required, the foreign
+     transaction manager commits the transaction on the foreign server by calling
+     <function>CommitForeignTransaction</function> and then
+     <productname>PostgreSQL</productname> commits locally. The foreign transaction
+     manager doesn't do any further change on foreign transactions from this point
+     forward. If any failure happens during the transaction for whatever reason,
+     for example a network failure or user request until
+     <productname>PostgreSQL</productname> commits locally the foreign transaction
+     manager changes over to rollback and calls
+     <function>RollbackForeignTransaction</function> for every foreign servers to
+     close the current transaction on foreign servers.
+    </para>
+
+    <para>
+     When two-phase commit is required, after committed locally, the transaction
+     commits will wait for all prepared foreign transaction to be resolved before
+     the commit completes. One foreign transaction resolver is responsible for
+     foreign transaction resolution on a database.
+     <function>ResolverForeignTransaction</function> is called by the foreign
+     transaction resolver process when resolution.
+     <function>ResolveForeignTransaction</function> is also be called
+     when user executes <function>pg_resovle_fdw_xact</function> function.
+    </para>
+  </sect1>
  </chapter>
diff --git a/doc/src/sgml/filelist.sgml b/doc/src/sgml/filelist.sgml
index 48ac14a..38d6fcb 100644
--- a/doc/src/sgml/filelist.sgml
+++ b/doc/src/sgml/filelist.sgml
@@ -49,6 +49,7 @@
 <!ENTITY wal           SYSTEM "wal.sgml">
 <!ENTITY logical-replication    SYSTEM "logical-replication.sgml">
 <!ENTITY jit    SYSTEM "jit.sgml">
+<!ENTITY distributed-transaction    SYSTEM "distributed-transaction.sgml">
 
 <!-- programmer's guide -->
 <!ENTITY bgworker   SYSTEM "bgworker.sgml">
